/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#include "JSAnimationEffectReadOnly.h"
#include "JSDOMConvertDictionary.h"
#include "JSDOMWrapper.h"
#include "KeyframeEffectReadOnly.h"

namespace WebCore {

class JSKeyframeEffectReadOnly : public JSAnimationEffectReadOnly {
public:
    using Base = JSAnimationEffectReadOnly;
    using DOMWrapped = KeyframeEffectReadOnly;
    static JSKeyframeEffectReadOnly* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<KeyframeEffectReadOnly>&& impl)
    {
        JSKeyframeEffectReadOnly* ptr = new (NotNull, JSC::allocateCell<JSKeyframeEffectReadOnly>(globalObject->vm().heap)) JSKeyframeEffectReadOnly(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);
    static KeyframeEffectReadOnly* toWrapped(JSC::VM&, JSC::JSValue);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    KeyframeEffectReadOnly& wrapped() const
    {
        return static_cast<KeyframeEffectReadOnly&>(Base::wrapped());
    }
protected:
    JSKeyframeEffectReadOnly(JSC::Structure*, JSDOMGlobalObject&, Ref<KeyframeEffectReadOnly>&&);

    void finishCreation(JSC::VM&);
};

JSC::JSValue toJS(JSC::ExecState*, JSDOMGlobalObject*, KeyframeEffectReadOnly&);
inline JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, KeyframeEffectReadOnly* impl) { return impl ? toJS(state, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject*, Ref<KeyframeEffectReadOnly>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::ExecState* state, JSDOMGlobalObject* globalObject, RefPtr<KeyframeEffectReadOnly>&& impl) { return impl ? toJSNewlyCreated(state, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<KeyframeEffectReadOnly> {
    using WrapperClass = JSKeyframeEffectReadOnly;
    using ToWrappedReturnType = KeyframeEffectReadOnly*;
};
template<> KeyframeEffectReadOnly::BasePropertyIndexedKeyframe convertDictionary<KeyframeEffectReadOnly::BasePropertyIndexedKeyframe>(JSC::ExecState&, JSC::JSValue);

template<> KeyframeEffectReadOnly::BaseKeyframe convertDictionary<KeyframeEffectReadOnly::BaseKeyframe>(JSC::ExecState&, JSC::JSValue);

template<> KeyframeEffectReadOnly::BaseComputedKeyframe convertDictionary<KeyframeEffectReadOnly::BaseComputedKeyframe>(JSC::ExecState&, JSC::JSValue);

JSC::JSObject* convertDictionaryToJS(JSC::ExecState&, JSDOMGlobalObject&, const KeyframeEffectReadOnly::BaseComputedKeyframe&);


} // namespace WebCore
